Index: admin/install/index.php
===================================================================
--- admin/install/index.php	(revision 2319)
+++ admin/install/index.php	(revision 2507)
@@ -64,5 +64,5 @@
 	$u_pwd = !empty($_POST['u_pwd']) ? $_POST['u_pwd'] : null;
 	$u_pwd2 = !empty($_POST['u_pwd2']) ? $_POST['u_pwd2'] : null;
-	
+
 	try
 	{
@@ -77,5 +77,5 @@
 			throw new Exception(__('Invalid email address'));
 		}
-		
+
 		if (empty($u_pwd)) {
 			throw new Exception(__('No password given'));
@@ -87,5 +87,5 @@
 			throw new Exception(__('Password must contain at least 6 characters.'));
 		}
-		
+
 		# Try to guess timezone
 		$default_tz = 'Europe/London';
@@ -104,12 +104,12 @@
 			}
 		}
-		
+
 		# Create schema
 		$_s = new dbStruct($core->con,$core->prefix);
 		require dirname(__FILE__).'/../../inc/dbschema/db-schema.php';
-		
+
 		$si = new dbStruct($core->con,$core->prefix);
 		$changes = $si->synchronize($_s);
-		
+
 		# Create user
 		$cur = $core->con->openCursor($core->prefix.'user');
@@ -126,10 +126,10 @@
 		$cur->user_options = serialize($core->userDefaults());
 		$cur->insert();
-		
+
 		$core->auth->checkUser($u_login);
-		
+
 		$admin_url = preg_replace('%install/index.php$%','',$_SERVER['REQUEST_URI']);
 		$root_url = preg_replace('%/admin/install/index.php$%','',$_SERVER['REQUEST_URI']);
-		
+
 		# Create blog
 		$cur = $core->con->openCursor($core->prefix.'blog');
@@ -139,5 +139,5 @@
 		$core->addBlog($cur);
 		$core->blogDefaults($cur->blog_id);
-		
+
 		$blog_settings = new dcSettings($core,'default');
 		$blog_settings->addNamespace('system');
@@ -146,5 +146,5 @@
 		$blog_settings->system->put('public_url',$root_url.'/public');
 		$blog_settings->system->put('themes_url',$root_url.'/themes');
-		
+
 		# date and time formats
 		$formatDate = __('%A, %B %e %Y');
@@ -160,11 +160,11 @@
 		}
 		$blog_settings->system->put('date_format',$formatDate);
-		$blog_settings->system->put('date_formats',serialize($date_formats),'string','Date formats examples',true);
-		$blog_settings->system->put('time_formats',serialize($time_formats),'string','Time formats examples',true);
-		
+		$blog_settings->system->put('date_formats',serialize($date_formats),'string','Date formats examples',true,true);
+		$blog_settings->system->put('time_formats',serialize($time_formats),'string','Time formats examples',true,true);
+
 		# Add repository URL for themes and plugins
-		$blog_settings->system->put('store_plugin_url','http://update.dotaddict.org/dc2/plugins.xml','string','Plugins XML feed location',true);
-		$blog_settings->system->put('store_theme_url','http://update.dotaddict.org/dc2/themes.xml','string','Themes XML feed location',true);
-		
+		$blog_settings->system->put('store_plugin_url','http://update.dotaddict.org/dc2/plugins.xml','string','Plugins XML feed location',true,true);
+		$blog_settings->system->put('store_theme_url','http://update.dotaddict.org/dc2/themes.xml','string','Themes XML feed location',true,true);
+
 		# Add Dotclear version
 		$cur = $core->con->openCursor($core->prefix.'version');
@@ -172,8 +172,8 @@
 		$cur->version = (string) DC_VERSION;
 		$cur->insert();
-		
+
 		# Create first post
 		$core->setBlog('default');
-		
+
 		$cur = $core->con->openCursor($core->prefix.'post');
 		$cur->user_id = $u_login;
@@ -188,5 +188,5 @@
 		$cur->post_open_tb = 0;
 		$post_id = $core->blog->addPost($cur);
-		
+
 		# Add a comment to it
 		$cur = $core->con->openCursor($core->prefix.'comment');
@@ -199,10 +199,10 @@
 			"view your blog's comments. Then you might remove or edit it.</p>");
 		$core->blog->addComment($cur);
-		
+
 		#  Plugins initialization
 		define('DC_CONTEXT_ADMIN',true);
 		$core->plugins->loadModules(DC_PLUGINS_ROOT);
 		$plugins_install = $core->plugins->installModules();
-		
+
 		# Add dashboard module options
 		$core->auth->user_prefs->addWorkspace('dashboard');
@@ -248,6 +248,6 @@
   <meta name="GOOGLEBOT" content="NOSNIPPET" />
   <title><?php echo __('Dotclear Install'); ?></title>
-  
-	<link rel="stylesheet" href="../style/install.css" type="text/css" media="screen" /> 
+
+	<link rel="stylesheet" href="../style/install.css" type="text/css" media="screen" />
 
   <script type="text/javascript" src="../js/jquery/jquery.js"></script>
@@ -264,5 +264,5 @@
       $(this).val(this.value.replace(login_re,''));
     });
-    
+
 	<?php echo "\$('#u_pwd').pwstrength({texts: ['".
 				sprintf(__('Password strength: %s'),__('very weak'))."', '".
@@ -271,7 +271,7 @@
 				sprintf(__('Password strength: %s'),__('strong'))."', '".
 				sprintf(__('Password strength: %s'),__('very strong'))."']});\n"; ?>
-    
+
     $('#u_login').parent().after($('<input type="hidden" name="u_date" value="' + Date().toLocaleString() + '" />'));
-    
+
     var password_link = $('<a href="#" id="obfus"><?php echo(__('show')); ?></a>').click(function() {
 			$('#password').show();
@@ -308,7 +308,7 @@
 	echo
 	'<h2>'.__('User information').'</h2>'.
-	
+
 	'<p>'.__('Please provide the following information needed to create the first user.').'</p>'.
-	
+
 	'<form action="index.php" method="post">'.
 	'<fieldset><legend>'.__('User information').'</legend>'.
@@ -320,5 +320,5 @@
 	form::field('u_email',30,255,html::escapeHTML($u_email)).'</p>'.
 	'</fieldset>'.
-	
+
 	'<fieldset><legend>'.__('Username and password').'</legend>'.
 	'<p><label for="u_login" class="required"><abbr title="'.__('Required field').'">*</abbr> '.__('Username:').' '.
@@ -337,5 +337,5 @@
 	form::password('u_pwd2',30,255).'</label></p>'.
 	'</fieldset>'.
-	
+
 	'<p><input type="submit" value="'.__('Save').'" /></p>'.
 	'</form>';
@@ -361,12 +361,12 @@
 		$plugins_install_result .= '</ul></div>';
 	}
-	
+
 	echo
 	'<h2>'.__('All done!').'</h2>'.
-	
+
 	$plugins_install_result.
-	
+
 	'<p class="success">'.__('Dotclear has been successfully installed. Here is some useful information you should keep.').'</p>'.
-	
+
 	'<h3>'.__('Your account').'</h3>'.
 	'<ul>'.
@@ -374,5 +374,5 @@
 	'<li>'.__('Password:').' <strong id="password">'.html::escapeHTML($u_pwd).'</strong></li>'.
 	'</ul>'.
-	
+
 	'<h3>'.__('Your blog').'</h3>'.
 	'<ul>'.
@@ -380,5 +380,5 @@
 	'<li>'.__('Administration interface:').' <strong>'.html::escapeHTML(http::getHost().$admin_url).'</strong></li>'.
 	'</ul>'.
-	
+
 	'<form action="../auth.php" method="post">'.
 	'<p><input type="submit" value="'.__('Manage your blog now').'" />'.