Index: inc/admin/actions/class.dcaction.php
===================================================================
--- inc/admin/actions/class.dcaction.php	(revision 2493)
+++ inc/admin/actions/class.dcaction.php	(revision 2566)
@@ -377,3 +377,2 @@
 
 }
-
Index: inc/admin/class.dc.favorites.php
===================================================================
--- inc/admin/class.dc.favorites.php	(revision 2376)
+++ inc/admin/class.dc.favorites.php	(revision 2566)
@@ -20,11 +20,11 @@
 	/** @var dcCore dotclear core instance */
 	protected $core;
-	
+
 	/** @var array list of favorite definitions  */
 	protected $fav_defs;
-	
+
 	/** @var dcWorkspace current favorite landing workspace */
 	protected $ws;
-	
+
 	/** @var array list of user-defined favorite ids */
 	protected $local_prefs;
@@ -32,11 +32,11 @@
 	/** @var array list of globally-defined favorite ids */
 	protected $global_prefs;
-	
-	/** @var array list of user preferences (either one of the 2 above, or not!) */	
+
+	/** @var array list of user preferences (either one of the 2 above, or not!) */
 	protected $user_prefs;
-	
+
     /**
      * Class constructor
-     * 
+     *
      * @param mixed  $core   dotclear core
      *
@@ -50,5 +50,5 @@
 		$this->ws = $core->auth->user_prefs->addWorkspace('dashboard');
 		$this->user_prefs = array();
-		
+
 		if ($this->ws->prefExists('favorites')) {
 			$this->local_prefs = @unserialize($this->ws->getLocal('favorites'));
@@ -64,9 +64,9 @@
 			// No favorite defined ? Huhu, let's go for a migration
 			$this->migrateFavorites();
-		}	
+		}
 		defaultFavorites::initDefaultFavorites($this);
 	}
-	
-	
+
+
     /**
      * setup - sets up favorites, fetch user favorites (against his permissions)
@@ -84,5 +84,5 @@
    /**
      * getFavorite - retrieves a favorite (complete description) from its id.
-     * 
+     *
      * @param string  $id   the favorite id, or an array having 1 key 'name' set to id, ther keys are merged to favorite.
      *
@@ -117,8 +117,8 @@
 		return $fattr;
 	}
-	
+
    /**
      * getFavorites - retrieves a list of favorites.
-     * 
+     *
      * @param string  $ids   an array of ids, as defined in getFavorite.
      *
@@ -137,5 +137,5 @@
 		return $prefs;
 	}
-		
+
    /**
      * setUserPrefs - get user favorites from settings. These are complete favorites, not ids only
@@ -180,7 +180,7 @@
 			}
 		}
-			
-	}
-	
+
+	}
+
    /**
      * migrateFavorites - migrate dc < 2.6 favorites to new format
@@ -208,6 +208,6 @@
 	}
 
-	
-	
+
+
    /**
      * legacyFavorites - handle legacy favorites using adminDashboardFavs behavior
@@ -231,7 +231,7 @@
 			$this->register ($v[0], $fav);
 		}
-		
-	}
-	
+
+	}
+
    /**
      * getUserFavorites - returns favorites that correspond to current user
@@ -245,5 +245,5 @@
 		return $this->user_prefs;
 	}
-	
+
 
    /**
@@ -273,5 +273,5 @@
 		$this->ws->put('favorites',serialize($ids),null,null,true,$global);
 	}
-	
+
    /**
      * getAvailableFavoritesIDs - returns all available fav ids
@@ -319,5 +319,5 @@
 		}
 	}
-	
+
    /**
      * appendDashboardIcons - adds favorites icons to index page
@@ -336,7 +336,7 @@
 			$icons[$k]=new ArrayObject(array($v['title'],$v['url'],$v['large-icon']));
 			$this->core->callBehavior('adminDashboardFavsIcon',$this->core,$k,$icons[$k]);
-		}		
-	}
-	
+		}
+	}
+
    /**
      * register - registers a new favorite definition
@@ -358,12 +358,12 @@
 		return $this;
 	}
-	
+
    /**
      * registerMultiple - registers a list of favorites definition
 	 *
-     * @param array an array defining all favorites key is the id, value is the data. 
+     * @param array an array defining all favorites key is the id, value is the data.
 	 *				see register method for data format
      * @access public
-     */	
+     */
 	 public function registerMultiple($data) {
 		foreach ($data as $k=>$v) {
@@ -372,5 +372,5 @@
 		return $this;
 	}
-	
+
    /**
      * exists - tells whether a fav definition exists or not
@@ -381,9 +381,9 @@
 	 *
 	 * @return true if the fav definition exists, false otherwise
-     */	
+     */
 	public function exists($id) {
 		return isset($this->fav_defs[$id]);
 	}
-	
+
 }
 
Index: inc/admin/class.dc.menu.php
===================================================================
--- inc/admin/class.dc.menu.php	(revision 1179)
+++ inc/admin/class.dc.menu.php	(revision 2566)
@@ -16,5 +16,5 @@
 	private $id;
 	public $title;
-	
+
 	public function __construct($id,$title,$itemSpace='')
 	{
@@ -24,5 +24,5 @@
 		$this->items = array();
 	}
-	
+
 	public function addItem($title,$url,$img,$active,$show=true,$id=null,$class=null)
 	{
@@ -31,5 +31,5 @@
 		}
 	}
-	
+
 	public function prependItem($title,$url,$img,$active,$show=true,$id=null,$class=null)
 	{
@@ -38,5 +38,5 @@
 		}
 	}
-	
+
 	public function draw()
 	{
@@ -44,10 +44,10 @@
 			return '';
 		}
-		
+
 		$res =
 		'<div id="'.$this->id.'">'.
 		($this->title ? '<h3>'.$this->title.'</h3>' : '').
 		'<ul>'."\n";
-		
+
 		for ($i=0; $i<count($this->items); $i++)
 		{
@@ -59,10 +59,10 @@
 			}
 		}
-		
+
 		$res .= '</ul></div>'."\n";
-		
+
 		return $res;
 	}
-	
+
 	protected function itemDef($title,$url,$img,$active,$id=null,$class=null)
 	{
@@ -74,7 +74,7 @@
 			$ahtml = '';
 		}
-		
+
 		$img = dc_admin_icon_url($img);
-		
+
 		return
 		'<li'.(($active || $class) ? ' class="'.(($active) ? 'active ' : '').(($class) ? $class : '').'"' : '').
@@ -82,7 +82,6 @@
 		(($img) ? ' style="background-image: url('.$img.');"' : '').
 		'>'.
-		
+
 		'<a href="'.$link.'"'.$ahtml.'>'.$title.'</a></li>'."\n";
 	}
 }
-?>
Index: inc/admin/lib.admincombos.php
===================================================================
--- inc/admin/lib.admincombos.php	(revision 2154)
+++ inc/admin/lib.admincombos.php	(revision 2566)
@@ -14,5 +14,5 @@
 @ingroup DC_CORE
 @nosubgrouping
-@brief Admin combo library 
+@brief Admin combo library
 
 Dotclear utility class that provides reuseable combos across all admin
@@ -23,8 +23,8 @@
 	/** @var dcCore dcCore instance */
 	public static $core;
-	
+
 	/**
 	Returns an hierarchical categories combo from a category record
-	
+
 	@param	categories		<b>record</b>		the category record
 	@return	<b>array</b> the combo box (form::combo -compatible format)
@@ -44,8 +44,8 @@
 		return $categories_combo;
 	}
-	
+
 	/**
-	Returns available post status combo 
-	
+	Returns available post status combo
+
 	@return	<b>array</b> the combo box (form::combo -compatible format)
 	*/
@@ -57,8 +57,8 @@
 		return $status_combo;
 	}
-	
+
 	/**
 	Returns an users combo from a users record
-	
+
 	@param	users		<b>record</b>		the users record
 	@return	<b>array</b> the combo box (form::combo -compatible format)
@@ -70,36 +70,36 @@
 			$user_cn = dcUtils::getUserCN($users->user_id,$users->user_name,
 			$users->user_firstname,$users->user_displayname);
-			
+
 			if ($user_cn != $users->user_id) {
 				$user_cn .= ' ('.$users->user_id.')';
 			}
-			
-			$users_combo[$user_cn] = $users->user_id; 
+
+			$users_combo[$user_cn] = $users->user_id;
 		}
 		return $users_combo;
 	}
-	
+
 	/**
 	Returns an date combo from a date record
-	
+
 	@param	dates		<b>record</b>		the dates record
 	@return	<b>array</b> the combo box (form::combo -compatible format)
-	*/	
+	*/
 	public static function getDatesCombo($dates) {
 		$dt_m_combo= array();
 		while ($dates->fetch()) {
 			$dt_m_combo[dt::str('%B %Y',$dates->ts())] = $dates->year().$dates->month();
-		}		
+		}
 		return $dt_m_combo;
 	}
-	
+
 	/**
 	Returns an lang combo from a lang record
-	
+
 	@param	langs		<b>record</b>		the langs record
 	@param	with_available	<b>boolean</b>	if false, only list items from record
 											if true, also list available languages
 	@return	<b>array</b> the combo box (form::combo -compatible format)
-	*/	
+	*/
 	public static function getLangsCombo($langs,$with_available=false) {
 		$all_langs = l10n::getISOcodes(0,1);
@@ -124,10 +124,10 @@
 		return $langs_combo;
 	}
-	
+
 	/**
 	Returns a combo containing all available and installed languages for administration pages
-	
+
 	@return	<b>array</b> the combo box (form::combo -compatible format)
-	*/	
+	*/
 	public static function getAdminLangsCombo() {
 		$lang_combo = array();
@@ -139,10 +139,10 @@
 		return $lang_combo;
 	}
-	
+
 	/**
 	Returns a combo containing all available formaters in admin
-	
+
 	@return	<b>array</b> the combo box (form::combo -compatible format)
-	*/	
+	*/
 	public static function getFormatersCombo() {
 		foreach (self::$core->getFormaters() as $v) {
@@ -151,10 +151,10 @@
 		return $formaters_combo;
 	}
-	
+
 	/**
 	Returns a combo containing available blog statuses
-	
+
 	@return	<b>array</b> the combo box (form::combo -compatible format)
-	*/	
+	*/
 	public static function getBlogStatusesCombo() {
 		$status_combo = array();
@@ -164,10 +164,10 @@
 		return $status_combo;
 	}
-	
+
 	/**
 	Returns a combo containing available comment statuses
-	
+
 	@return	<b>array</b> the combo box (form::combo -compatible format)
-	*/	
+	*/
 	public static function getCommentStatusescombo() {
 		$status_combo = array();
Index: inc/admin/lib.moduleslist.php
===================================================================
--- inc/admin/lib.moduleslist.php	(revision 2490)
+++ inc/admin/lib.moduleslist.php	(revision 2566)
@@ -765,5 +765,5 @@
 			if (!empty($buttons)) {
 				if (in_array('checkbox', $cols)) {
-					echo 
+					echo
 					'<p class="checkboxes-helpers"></p>';
 				}
@@ -772,5 +772,5 @@
 			}
 		}
-		echo 
+		echo
 		'</form>';
 
@@ -1592,5 +1592,5 @@
 			if (!empty($buttons)) {
 				if (in_array('checkbox', $cols)) {
-					echo 
+					echo
 					'<p class="checkboxes-helpers"></p>';
 				}
Index: inc/admin/lib.pager.php
===================================================================
--- inc/admin/lib.pager.php	(revision 2386)
+++ inc/admin/lib.pager.php	(revision 2566)
@@ -16,5 +16,5 @@
 	protected $form_action;
 	protected $form_hidden;
-	
+
 	protected function getLink($li_class,$href,$img_src,$img_src_nolink,$img_alt,$enable_link) {
 		if ($enable_link) {
@@ -60,5 +60,5 @@
 		$this->form_action = $url['path'];
 	}
-	
+
 	/**
 	* Pager Links
@@ -103,10 +103,10 @@
 			($this->env < $this->nb_pages)
 		);
-		$htmlCurrent = 
+		$htmlCurrent =
 			'<li class="active"><strong>'.
 			sprintf(__('Page %s / %s'),$this->env,$this->nb_pages).
 			'</strong></li>';
-			
-		$htmlDirect = 
+
+		$htmlDirect =
 			($this->nb_pages > 1 ?
 				sprintf('<li class="direct-access">'.__('Direct access page %s'),
@@ -114,6 +114,6 @@
 				'<input type="submit" value="'.__('ok').'" class="reset" '.
 				'name="ok" />'.$this->form_hidden.'</li>' : '');
-		
-		$res =	
+
+		$res =
 			'<form action="'.$this->form_action.'" method="get">'.
 			'<div class="pager"><ul>'.
@@ -128,5 +128,5 @@
 			'</form>'
 		;
-		
+
 		return $this->nb_elements > 0 ? $res : '';
 	}
@@ -138,5 +138,5 @@
 	protected $rs;
 	protected $rs_count;
-	
+
 	public function __construct($core,$rs,$rs_count)
 	{
@@ -173,5 +173,5 @@
 			'<div class="table-outer">'.
 			'<table>';
-			
+
 			if( $filter ) {
 				$html_block .= '<caption>'.sprintf(__('List of %s entries match the filter.'), $this->rs_count).'</caption>';
@@ -179,5 +179,5 @@
 				$html_block .= '<caption class="hidden">'.__('Entries list').'</caption>';
 			}
-					
+
 			$html_block .= '<tr>'.
 			'<th colspan="2" class="first">'.__('Title').'</th>'.
@@ -189,26 +189,26 @@
 			'<th scope="col">'.__('Status').'</th>'.
 			'</tr>%s</table></div>';
-			
+
 			if ($enclose_block) {
 				$html_block = sprintf($enclose_block,$html_block);
 			}
-			
-			echo $pager->getLinks();
-			
+
+			echo $pager->getLinks();
+
 			$blocks = explode('%s',$html_block);
-			
+
 			echo $blocks[0];
-			
+
 			while ($this->rs->fetch())
 			{
 				echo $this->postLine(isset($entries[$this->rs->post_id]));
 			}
-			
+
 			echo $blocks[1];
-			
-			echo $pager->getLinks();
-		}
-	}
-	
+
+			echo $pager->getLinks();
+		}
+	}
+
 	private function postLine($checked)
 	{
@@ -218,5 +218,5 @@
 			$cat_link = '%2$s';
 		}
-		
+
 		if ($this->rs->cat_title) {
 			$cat_title = sprintf($cat_link,$this->rs->cat_id,
@@ -225,5 +225,5 @@
 			$cat_title = __('(No cat)');
 		}
-		
+
 		$img = '<img alt="%1$s" title="%1$s" src="images/%2$s" />';
 		switch ($this->rs->post_status) {
@@ -241,15 +241,15 @@
 				break;
 		}
-		
+
 		$protected = '';
 		if ($this->rs->post_password) {
 			$protected = sprintf($img,__('Protected'),'locker.png');
 		}
-		
+
 		$selected = '';
 		if ($this->rs->post_selected) {
 			$selected = sprintf($img,__('Selected'),'selected.png');
 		}
-		
+
 		$attach = '';
 		$nb_media = $this->rs->countMedia();
@@ -258,8 +258,8 @@
 			$attach = sprintf($img,sprintf($attach_str,$nb_media),'attach.png');
 		}
-		
+
 		$res = '<tr class="line'.($this->rs->post_status != 1 ? ' offline' : '').'"'.
 		' id="p'.$this->rs->post_id.'">';
-		
+
 		$res .=
 		'<td class="nowrap">'.
@@ -274,5 +274,5 @@
 		'<td class="nowrap status">'.$img_status.' '.$selected.' '.$protected.' '.$attach.'</td>'.
 		'</tr>';
-		
+
 		return $res;
 	}
@@ -290,5 +290,5 @@
 		{
 			$pager = new dcPager($page,$this->rs_count,$nb_per_page,10);
-			
+
 			$html_block =
 			'<div class="table-outer clear">'.
@@ -299,26 +299,26 @@
 			'<th scope="col">'.__('Status').'</th>'.
 			'</tr>%s</table></div>';
-			
+
 			if ($enclose_block) {
 				$html_block = sprintf($enclose_block,$html_block);
 			}
-			
-			echo $pager->getLinks();
-			
+
+			echo $pager->getLinks();
+
 			$blocks = explode('%s',$html_block);
-			
+
 			echo $blocks[0];
-			
+
 			while ($this->rs->fetch())
 			{
 				echo $this->postLine();
 			}
-			
+
 			echo $blocks[1];
-			
-			echo $pager->getLinks();
-		}
-	}
-	
+
+			echo $pager->getLinks();
+		}
+	}
+
 	private function postLine()
 	{
@@ -338,15 +338,15 @@
 				break;
 		}
-		
+
 		$protected = '';
 		if ($this->rs->post_password) {
 			$protected = sprintf($img,__('Protected'),'locker.png');
 		}
-		
+
 		$selected = '';
 		if ($this->rs->post_selected) {
 			$selected = sprintf($img,__('Selected'),'selected.png');
 		}
-		
+
 		$attach = '';
 		$nb_media = $this->rs->countMedia();
@@ -355,8 +355,8 @@
 			$attach = sprintf($img,sprintf($attach_str,$nb_media),'attach.png');
 		}
-		
+
 		$res = '<tr class="line'.($this->rs->post_status != 1 ? ' offline' : '').'"'.
 		' id="p'.$this->rs->post_id.'">';
-		
+
 		$res .=
 		'<td scope="row" class="maximal"><a href="'.$this->core->getPostAdminURL($this->rs->post_type,$this->rs->post_id).'" '.
@@ -367,5 +367,5 @@
 		'<td class="nowrap status">'.$img_status.' '.$selected.' '.$protected.' '.$attach.'</td>'.
 		'</tr>';
-		
+
 		return $res;
 	}
@@ -387,5 +387,5 @@
 		{
 			$pager = new dcPager($page,$this->rs_count,$nb_per_page,10);
-			
+
 			$comments = array();
 			if (isset($_REQUEST['comments'])) {
@@ -393,9 +393,9 @@
 					$comments[(integer)$v]=true;
 				}
-			}			
+			}
 			$html_block =
 			'<div class="table-outer">'.
 			'<table>';
-			
+
 			if( $filter ) {
 				$html_block .= '<caption>'.
@@ -408,5 +408,5 @@
 				$html_block .= '<caption class="hidden">'.__('Comments and trackbacks list').'</caption>';
 			}
-					
+
 			$html_block .= '<tr>'.
 			'<th colspan="2" scope="col" abbr="comm" class="first">'.__('Type').'</th>'.
@@ -420,26 +420,26 @@
 				$html_block = sprintf($enclose_block,$html_block);
 			}
-			
-			echo $pager->getLinks();
-			
+
+			echo $pager->getLinks();
+
 			$blocks = explode('%s',$html_block);
-			
+
 			echo $blocks[0];
-			
+
 			while ($this->rs->fetch())
 			{
 				echo $this->commentLine(isset($comments[$this->rs->comment_id]));
 			}
-			
+
 			echo $blocks[1];
-			
-			echo $pager->getLinks();
-		}
-	}
-	
+
+			echo $pager->getLinks();
+		}
+	}
+
 	private function commentLine($checked=false)
 	{
 		global $author, $status, $sortby, $order, $nb_per_page;
-		
+
 		$author_url =
 		'comments.php?n='.$nb_per_page.
@@ -448,13 +448,13 @@
 		'&amp;order='.$order.
 		'&amp;author='.rawurlencode($this->rs->comment_author);
-		
+
 		$post_url = $this->core->getPostAdminURL($this->rs->post_type,$this->rs->post_id);
-		
+
 		$comment_url = 'comment.php?id='.$this->rs->comment_id;
-		
+
 		$comment_dt =
 		dt::dt2str($this->core->blog->settings->system->date_format.' - '.
 		$this->core->blog->settings->system->time_format,$this->rs->comment_dt);
-		
+
 		$img = '<img alt="%1$s" title="%1$s" src="images/%2$s" />';
 		switch ($this->rs->comment_status) {
@@ -472,5 +472,5 @@
 				break;
 		}
-		
+
 		$post_title = html::escapeHTML($this->rs->post_title);
 		if (mb_strlen($post_title) > 70) {
@@ -480,8 +480,8 @@
 			$this->rs->comment_trackback ? __('trackback') : __('comment'),
 			html::escapeHTML($this->rs->comment_author));
-		
+
 		$res = '<tr class="line'.($this->rs->comment_status != 1 ? ' offline' : '').'"'.
 		' id="c'.$this->rs->comment_id.'">';
-		
+
 		$res .=
 		'<td class="nowrap">'.
@@ -497,7 +497,7 @@
 		html::escapeHTML($post_title).'</a>'.
 		($this->rs->post_type != 'post' ? ' ('.html::escapeHTML($this->rs->post_type).')' : '').'</td>';
-		
+
 		$res .= '</tr>';
-		
+
 		return $res;
 	}
@@ -519,9 +519,9 @@
 		{
 			$pager = new dcPager($page,$this->rs_count,$nb_per_page,10);
-			
+
 			$html_block =
 			'<div class="table-outer clear">'.
 			'<table>';
-			
+
 			if( $filter ) {
 				$html_block .= '<caption>'.sprintf(__('List of %s users match the filter.'), $this->rs_count).'</caption>';
@@ -529,5 +529,5 @@
 				$html_block .= '<caption class="hidden">'.__('Users list').'</caption>';
 			}
-					
+
 			$html_block .= '<tr>'.
 			'<th colspan="2" scope="col" class="first">'.__('Username').'</th>'.
@@ -537,33 +537,33 @@
 			'<th scope="col" class="nowrap">'.__('Entries (all types)').'</th>'.
 			'</tr>%s</table></div>';
-			
+
 			if ($enclose_block) {
 				$html_block = sprintf($enclose_block,$html_block);
 			}
-			
-			echo $pager->getLinks();
-			
+
+			echo $pager->getLinks();
+
 			$blocks = explode('%s',$html_block);
-			
+
 			echo $blocks[0];
-			
+
 			while ($this->rs->fetch())
 			{
 				echo $this->userLine();
 			}
-			
+
 			echo $blocks[1];
-			
-			echo $pager->getLinks();
-		}
-	}
-	
+
+			echo $pager->getLinks();
+		}
+	}
+
 	private function userLine()
 	{
 		$img = '<img alt="%1$s" title="%1$s" src="images/%2$s" />';
 		$img_status = '';
-		
+
 		$p = $this->core->getUserPermissions($this->rs->user_id);
-		
+
 		if (isset($p[$this->core->blog->id]['p']['admin'])) {
 			$img_status = sprintf($img,__('admin'),'admin.png');
Index: inc/admin/prepend.php
===================================================================
--- inc/admin/prepend.php	(revision 2277)
+++ inc/admin/prepend.php	(revision 2566)
@@ -24,8 +24,8 @@
 function dc_load_locales() {
 	global $_lang, $core;
-	
+
 	$_lang = $core->auth->getInfo('user_lang');
 	$_lang = preg_match('/^[a-z]{2}(-[a-z]{2})?$/',$_lang) ? $_lang : 'en';
-	
+
 	l10n::lang($_lang);
 	if (l10n::set(dirname(__FILE__).'/../../locales/'.$_lang.'/date') === false && $_lang != 'en') {
@@ -40,10 +40,10 @@
 {
 	global $core;
-	
+
 	$core->auth->user_prefs->addWorkspace('interface');
 	$user_ui_iconset = @$core->auth->user_prefs->interface->iconset;
 	if (($user_ui_iconset) && ($img)) {
 		$icon = false;
-		if ((preg_match('/^images\/menu\/(.+)$/',$img,$m)) || 
+		if ((preg_match('/^images\/menu\/(.+)$/',$img,$m)) ||
 			(preg_match('/^index\.php\?pf=(.+)$/',$img,$m))) {
 			if ($m[1]) {
@@ -65,9 +65,9 @@
 	# We have session information in constants
 	$_COOKIE[DC_SESSION_NAME] = DC_AUTH_SESS_ID;
-	
+
 	if (!$core->auth->checkSession(DC_AUTH_SESS_UID)) {
 		throw new Exception('Invalid session data.');
 	}
-	
+
 	# Check nonce from POST requests
 	if (!empty($_POST))
@@ -77,12 +77,12 @@
 		}
 	}
-	
+
 	if (empty($_SESSION['sess_blog_id'])) {
 		throw new Exception('Permission denied.');
 	}
-	
+
 	# Loading locales
 	dc_load_locales();
-	
+
 	$core->setBlog($_SESSION['sess_blog_id']);
 	if (!$core->blog->id) {
@@ -100,5 +100,5 @@
 			$p[3] = '/';
 			call_user_func_array('setcookie',$p);
-			
+
 			http::redirect('auth.php');
 		}
@@ -108,5 +108,5 @@
 			,20);
 	}
-	
+
 	# Check nonce from POST requests
 	if (!empty($_POST))
@@ -119,6 +119,6 @@
 		}
 	}
-	
-	
+
+
 	if (!empty($_REQUEST['switchblog'])
 	&& $core->auth->getPermissions($_REQUEST['switchblog']) !== false)
@@ -131,5 +131,5 @@
 			unset($_SESSION['media_manager_page']);
 		}
-		
+
 		# Removing switchblog from URL
 		$redir = $_SERVER['REQUEST_URI'];
@@ -139,5 +139,5 @@
 		exit;
 	}
-	
+
 	# Check blog to use and log out if no result
 	if (isset($_SESSION['sess_blog_id']))
@@ -154,8 +154,8 @@
 		}
 	}
-	
+
 	# Loading locales
 	dc_load_locales();
-	
+
 	if (isset($_SESSION['sess_blog_id'])) {
 		$core->setBlog($_SESSION['sess_blog_id']);
@@ -165,5 +165,5 @@
 	}
 
-/*	
+/*
 	# Check add to my fav fired
 	if (!empty($_REQUEST['add-favorite'])) {
@@ -184,5 +184,5 @@
 	}
 	unset($f);
-	
+
 	if (($hfiles = @scandir($locales_root.$_lang.'/help')) !== false)
 	{
@@ -205,6 +205,6 @@
 	# [] : Title, URL, small icon, large icon, permissions, id, class
 	# NB : '*' in permissions means any, null means super admin only
-	
-	
+
+
 	# Menus creation
 	$_menu = new ArrayObject();
@@ -219,12 +219,12 @@
 	$core->plugins->loadModules(DC_PLUGINS_ROOT,'admin',$_lang);
 	$core->favs->setup();
-	
+
 	if (!$user_ui_nofavmenu) {
 		$core->favs->appendMenu($_menu);
 	}
 
-	
+
 	# Set menu titles
-	
+
 	$_menu['System']->title = __('System settings');
 	$_menu['Blog']->title = __('Blog');
@@ -256,5 +256,5 @@
 		preg_match('/post.php$/',$_SERVER['REQUEST_URI']),
 		$core->auth->check('usage,contentadmin',$core->blog->id));
-	
+
 	$_menu['System']->prependItem(__('Update'),'update.php','images/menu/update.png',
 		preg_match('/update.php(\?.*)?$/',$_SERVER['REQUEST_URI']),
@@ -273,8 +273,7 @@
 		$core->auth->isSuperAdmin() ||
 		$core->auth->check('usage,contentadmin',$core->blog->id) && $core->auth->getBlogCount() > 1);
-	
+
 	if (empty($core->blog->settings->system->jquery_migrate_mute)) {
 		$core->blog->settings->system->put('jquery_migrate_mute', true, 'boolean', 'Mute warnings for jquery migrate plugin ?', false);
 	}
 }
-?>